# Getting Started (請依據App的內容填寫此說明手冊)

## Environment Setup 

## (可直接複製此區，若App內需要額外的環境安裝事項，也請在此區補充說明)

### Platform and OS Requirements:

| OS           | Platform      | Python Version          |
| ------------ | ------------- | ----------------------- |
| Windows 10   | x86_64 64-bit | 3.5-3.9 (x86_64 64-bit) |
| Ubuntu 18.04 | x86_64 64-bit | 3.5-3.9 (x86_64 64-bit) |

### General

* opencv-python (Install using `pip install opencv-python`)
* numpy (Install using `pip install numpy`)

### Ubuntu

```bash
$ pip install ./package/{platform}/KneronPLUS-X.X.X-py3-none-any.whl
```

> #### Ubuntu only step
> * Need to install libusb and config USB permission on Ubuntu 
>   ```bash
>   $ sudo bash install_libusb.sh
>   ```
> * Or add following lines in `/etc/udev/rules.d/10-local.rules`
>   ```text
>   KERNEL=="ttyUSB*",ATTRS{idVendor}=="067b",ATTRS{idProduct}=="2303",MODE="0777",SYMLINK+="kneron_uart"
>   KERNEL=="ttyUSB*",ATTRS{idVendor}=="1a86",ATTRS{idProduct}=="7523",MODE="0777",SYMLINK+="kneron_pwr"
>   SUBSYSTEM=="usb",ATTRS{idVendor}=="3231",ATTRS{idProduct}=="0100",MODE="0666"
>   SUBSYSTEM=="usb",ATTRS{idVendor}=="3231",ATTRS{idProduct}=="0200",MODE="0666"
>   SUBSYSTEM=="usb",ATTRS{idVendor}=="3231",ATTRS{idProduct}=="0720",MODE="0666"
>   ```
>   and restatr service by following command
>   ```bash
>   $ sudo udevadm trigger
>   ```

### Windows

```bash
$ pip install .\package\{platform}\KneronPLUS-X.X.X-py3-none-any.whl
```




## Quick Start  (執行指令)
```bash
$ python app.py
```



## Usage (詳細指令說明，有額外功能者也請在此處詳述)

```bash
$ python app.py -h
```

* Show all input parameters for the APP.

```bash
$ python app.py
```

* Run APP with first scanned kneron device.

```bash
$ python app.py -p port_id
```

* Run APP with  specified port ID for connecting device (`Hint: find USB port ID by ScanDevice.py`).

```bash
$ python ScanDevice.py
```

* Show all connected Kneron AI Devices

## Common Problem (常見問題解決方式)
* If pip install/run application fails, it may cause by using python 2.X as python interpreter. Please make sure the interpreter and pip is `Python 3` on the host:
    ```bash
    # check pip version
    $ pip -V
    $ pip3 -V
    
    # check python interpreter version
    $ python -V
    $ python3 -V
    ```

    You also can install package by specify python interpreter by following scripts:
    ```bash
    $ python -m pip install {package_path}
    # or
    $ python3 -m pip install {package_path}
    ```
